{ Memorvox - O Jogo da Memria }
{ Por Lucas Alexandre }

program memorvox;

uses dvcrt, dvwin, windows, sysutils;

type
marca1 = record
marcado: boolean;
bloco: integer;
texto: string[20];
end;

marca2 = record
marcado: boolean;
bloco: integer;
texto: string[20];
end;

const
MAXBLOCOS = 100;
MAXPAL = 250;

var
objs: array [1..MAXPAL] of string;
TabPronto: array[1..MAXBLOCOS] of string;
TabJogo: array[1..MAXBLOCOS] of string;
i, coluna, linha, TabC, TabL, TabBloco, TamTab, tentativas: integer;
linhas: Byte;
jogando, MostrandoTab, proximo: boolean;
tmarca1: marca1;
tmarca2: marca2;

{ Fim do jogo }

procedure fim;
begin
    clrscr;
    sintWriteln('Obrigado por jogar o Memorvox.');
    sintWriteln('Fim do Memorvox.');
    sintFim;
    DoneWinCrt;
    end;

{ Mistura os objetos de um tabuleiro }

procedure MisturaObjs;
var bloco: integer; s: string;
begin
    for i := 1 to TamTab do
    begin
        randomize;
        bloco := 1+random(TamTab-1);
        s := TabPronto[i];
        TabPronto[i] := TabPronto[bloco];
        TabPronto[bloco] := s;
    end;
end;

{ Gera um novo tabuleiro }

procedure GeraTab;
var
bloco, j, range: integer;
s: string;
o, o2: char;
begin

    sintWriteln('Selecione um tabuleiro para o jogo:');
    writeln;
    sintWriteln('Tecle:');
    writeln;
    sintWriteln('1 para 4x4 - 16 peas');
    sintWriteln('2 para 6x5 - 30 peas');
    sintWriteln('3 para9x6 - 54 peas');

    sintLeTecla(o, o2);

    case (o) of
    '1': begin
    TabL := 4;
    TabC := 4;
    end;
    '2': begin
    TabL := 6;
    TabC := 5;
    end;
    '3': begin
    TabL := 9;
    TabC := 6;
    end;
    else
    TabL := 4;
    TabC := 4;
    end;

    TamTab := TabL*TabC;

    { Gera o tabuleiro }

    randomize;
    range := random(linhas)-TamTab div 2;

    while range < 1 do  {  Garante que o resultado no ser inferior a 1 }
    begin
        randomize;
        range := random(linhas)-TamTab div 2;
    end;

    for i := 1 to TamTab div 2 do
    begin
     TabPronto[i] := objs[range];  {  Transfere parte dos objetos do ndice para o jogo }
    range := range+1;
    end;

    range := range-TamTab div 2;

    for i := TamTab div 2+1 to TamTab do
    begin
    TabPronto[i] := objs[range];
    range := range+1;
    end;

    for i := 1 to TamTab do MisturaObjs;  {  Mistura os objetos do jogo }

    end;

{ L o arquivo de objetos e cria uma lista }

procedure LeArqObjs;
var
arq: text;
s: string;
begin

    if not fileExists('C:\winvox\memorvox.mem') then
    begin
        sintWriteln('No achei o arquivo de objetos.');
    fim;
    end
    else
    assign(arq,'C:\winvox\memorvox.mem');
    reset (arq);

    while not eof (arq) do
    begin
        readln (arq, s);
    linhas := linhas+1;
    end;

    if linhas > 250 then
    begin
        sintWriteln('O arquivo do ndice de palavras ultrapassou 250 palavras.');
    fim;
    end
    else
    if linhas = 1 then
    begin    
        sintWriteln('O arquivo do ndice de palavras est vazio.');
    fim;
    end;

    reset (arq);

    for i := 1 to linhas do
    begin
        readln(arq, objs[i]);
    end;

    close (arq);

    end;

{ Controla a seleo de objetos no tabuleiro }

procedure TabSelec(o, o2: char);
begin

    if (linha = 1) and (coluna = 1) then TabBloco := 1;

    if o2 = CIMA then
    begin

        if linha = 1 then
    begin
        sintBip;
    sintWriteln(TabJogo[coluna]);
        exit;
    end
        else
        linha := linha-1;
    sintclek;
    TabBloco := TabBloco-TabC;
    if linha = 1 then TabBloco := coluna;
    end;

    if o2 = BAIX then
    begin

        if linha = TabL then
    begin
        sintBip;
    sintWriteln(TabJogo[TabBloco]);
        exit;
        end
        else
        linha := linha+1;
        sintClek;
    TabBloco := TabBloco+TabC;
    if linha = 1 then TabBloco := coluna;
            end;

    if o2 = DIR then
    begin

        if coluna = TabC then
        begin
        sintBip;
    sintWriteln(TabJogo[TabBloco]);
        exit;
        end
        else
        coluna := coluna+1;
        sintClek;
    TabBloco := TabBloco+1;
        end;

    if o2 = ESQ then
    begin

        if coluna = 1 then
        begin
        sintBip;
    sintWriteln(TabJogo[TabBloco]);
        exit;
        end
        else
        coluna := coluna-1;
        sintClek;
    TabBloco := TabBloco-1;
        end;
end;

{ Mostra o tabuleiro }

procedure MostraTab;
var o, o2: char;
begin

    sintLeTecla (o, o2);

    if o = ESC then MostrandoTab := false;

        if upcase(o) = 'L' then
    begin
    sintWriteln(intToStr(linha));
    exit;
    end;

        if upcase(o) = 'K' then
    begin
 sintWriteln(intToStr(coluna));
    exit;
    end;

    TabSelec(o, o2);

    sintWriteln(TabPronto[TabBloco]);

    end;

{ Desiste do jogo }

procedure desiste;
begin
    fim;
    end;


{ Ganhou o jogo }

procedure ganhoujogo;
begin
    clrscr;
    sintSom('GANHOU');
    sintWriteln('Voc fez: ' + intToStr(tentativas) + ' tentativas');
    fim;
    end;

{ Verifica se o tabuleiro jogvel  igual ao original (revelado ) }

procedure ChecaTab;
var j: integer;
begin

    { Verifica se o tabuleiro  igual ao original (revelado) }

    for i := 1 to TamTab do          if TabJogo[i] = TabPronto[i] then j := j+1;

    if j = TamTab then
    begin
        jogando := false;
    ganhoujogo;
    end;
end;

{ Controla o jogo }

procedure joga;
var o, o2: char;
begin

    ChecaTab;

    sintLeTecla(o, o2);

    ChecaTab;

    if o = ESC then desiste;

    if upcase(o) = 'K' then
    begin
     sintWriteInt(coluna);
    exit;
    end;

    if upcase(o) = 'L' then
    begin
 sintWriteInt(linha);
    exit;
    end;

    TabSelec(o, o2);

    sintWriteln(TabJogo[TabBloco]);

    if o = ESC then desiste;

    if o = ENTER then
    begin

    if (tmarca1.marcado) and (tmarca1.bloco = TabBloco) then
    begin
    tentativas := tentativas+1;
        tmarca1.marcado := false;
    sintBip;
    sintWriteln(TabPronto[tmarca1.bloco]);
    proximo := false;
    exit;
        end;

    if (o = ENTER) and (tmarca1.marcado) then
    begin
    tmarca2.marcado := true;
    tmarca2.bloco := TabBloco;
    tmarca2.texto := TabPronto[TabBloco];
    sintWriteln(TabPronto[tmarca2.bloco]);
    end;

    if proximo then
    begin
    if (TabPronto[tmarca1.bloco] = tmarca1.texto) and (TabPronto[tmarca1.bloco] = tmarca2.texto) then
    begin
    proximo := false;
    TabJogo[tmarca1.bloco] := TabPronto[tmarca1.bloco];
    TabJogo[tmarca2.bloco] := TabPronto[tmarca2.bloco];
    sintSom('ACERTO');
    sintWriteln(tmarca1.texto);
    exit;
    end
    else
    tentativas := tentativas+1;
    proximo := false;
    tmarca1.marcado := false;
    tmarca2.marcado := false;
    sintBip;
    exit;
    end;
    end;

    if o = Enter then
    begin
        tmarca1.marcado := true;
        tmarca1.bloco := TabBloco;
        tmarca1.texto := TabPronto[TabBloco];
    proximo := true;
    end;

    if (tmarca1.marcado) and (tmarca1.bloco = TabBloco) then sintWriteln(TabPronto[tmarca1.bloco]);

    end;

{ Inicializao }

procedure inicializa;
begin
sintInic(0, '');
chdir ('C:\winvox\som\Memorvox');
clrscr;
setWindowText (crtWindow, 'Memorvox');
sintWriteln('Memorvox - O jogo da memria');
writeln;
end;

{ Apresenta instrues do jogo }

procedure instrucoes;
begin
    clrscr;
    sintWriteln('O jogo apresenta um tabuleiro com uma quantidade');
    sintWriteln('de linhas e colunas escolhidas por voc.');
    writeln;
    sintWriteln('Cada coluna apresenta um objeto.');
    writeln;
    sintWriteln('O objetivo do jogo  formar pares de dois objetos');
    sintWriteln('iguais no tabuleiro, os quais dvem serem procurados pelo jogador');
    writeln;
    sintWriteln('Em todo o tabuleiro, sempre existiro dois objetos');
    sintWriteln('iguais,');
    writeln;
    sintWriteln('Usa-se as setas para percorrer o tabuleiro.');
    writeln;
    sintWriteln('Comandos durante o jogo:');
    writeln;
    sintWriteln('K - Informa coluna atual na linha.');
    sintWriteln('L - Informa a linha atual.');
    sintWriteln('Enter - Marca uma carta para comparao.');
    sintwriteln('Se Enter for usado em uma carta previamente marcada,');
    sintWriteln('ela ser desmarcada.');
    writeln;
    sintWriteln('Ao gerar o tabuleiro, ele ser apresentado jogador.');
    writeln;
    sintWriteln('Enter sempre  utilizado para marcar um bloco qualquer');
    sintWriteln('no tabuleiro e para marcar o bloco a ser comparado com o primeiro');
    sintWriteln('marcado.');
    writeln;
    sintWriteln('O jogo trabalha com um ndice de objetos, no arquivo');
    sintWriteln('C:\winvox\memorvox.mem. Este arquivo pode ser alterado pelo usurio');
    sintWriteln('e pode receber at 250 objetos.');
    end;

{ Programa Principal }

var o, o2: char;
begin

inicializa;
LeArqObjs;

clrscr;

    sintWriteln('Deseja instrues?');

    sintLeTecla (o, o2);

    if upcase(o) = 'S' then instrucoes;

sintWriteln('Gerando tabuleiro...');
GeraTab;
clrscr;
sintWriteln('Use as setas para conhecer o tabuleiro, ESC termina a reviso.');
linha := 1;
coluna := 1;
MostrandoTab := true;
while mostrandoTab do MostraTab;
jogando := true;
linha := 1;
coluna := 1;
while jogando do joga;
end.
